/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: wamp_subscriber.h 108 2015-06-11 09:15:46Z coas-nagasima $
 */

#ifndef WAMP_SUBSCRIBER_H
#define WAMP_SUBSCRIBER_H

typedef struct wamp_subscriber
{
	struct wamp_state *s;
	int id;
} wamp_subscriber_t;

void wamp_subscriber_subscribed(wamp_subscriber_t *subscriber);
void wamp_subscriber_subscribed_request_id(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_subscribed_subscription_id(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_subscribed_close(struct wamp_state *s);

void wamp_subscriber_unsubscribed(wamp_subscriber_t *subscriber);
void wamp_subscriber_unsubscribed_request_id(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_unsubscribed_close(struct wamp_state *s);

void wamp_subscriber_event(wamp_subscriber_t *subscriber);
void wamp_subscriber_event_subscription_id(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_event_publication_id(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_event_details(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_event_details_param(wamp_subscriber_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_subscriber_event_arguments(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_event_arguments_param(wamp_subscriber_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_subscriber_event_argumentskw(wamp_subscriber_t *s, const char *value);
void wamp_subscriber_event_argumentskw_param(wamp_subscriber_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_subscriber_event_close(struct wamp_state *s);

#endif // WAMP_SUBSCRIBER_H
